# coding: utf-8

"""
    Antimatter Security Lakehouse Public API

    Interact with the Antimatter ASL API

    The version of the OpenAPI document: 0.0.2
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from asl_api.models.core_v1alpha1_data_source_spec_gold_add_tables_inner import CoreV1alpha1DataSourceSpecGoldAddTablesInner
from asl_api.models.core_v1alpha1_data_source_spec_gold_custom_inner import CoreV1alpha1DataSourceSpecGoldCustomInner
from asl_api.models.core_v1alpha1_data_source_spec_gold_preset_overrides_value import CoreV1alpha1DataSourceSpecGoldPresetOverridesValue
from typing import Optional, Set
from typing_extensions import Self

class CoreV1alpha1DataSourceSpecGold(BaseModel):
    """
    CoreV1alpha1DataSourceSpecGold
    """ # noqa: E501
    use_preset: Optional[StrictStr] = Field(default=None, description="The name of the preset to use for transforming data from silver to gold including clustering, table destinations, and other transformation steps. ", alias="usePreset")
    preset_overrides: Optional[Dict[str, CoreV1alpha1DataSourceSpecGoldPresetOverridesValue]] = Field(default=None, alias="presetOverrides")
    add_tables: Optional[List[CoreV1alpha1DataSourceSpecGoldAddTablesInner]] = Field(default=None, description="A list of tables to create in the gold schema. Each table can have its own clustering,  filtering, and transformation steps. ", alias="addTables")
    custom: Optional[List[CoreV1alpha1DataSourceSpecGoldCustomInner]] = Field(default=None, description="A list of custom notebooks for data transformation to different gold tables.")
    __properties: ClassVar[List[str]] = ["usePreset", "presetOverrides", "addTables", "custom"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CoreV1alpha1DataSourceSpecGold from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in preset_overrides (dict)
        _field_dict = {}
        if self.preset_overrides:
            for _key_preset_overrides in self.preset_overrides:
                if self.preset_overrides[_key_preset_overrides]:
                    _field_dict[_key_preset_overrides] = self.preset_overrides[_key_preset_overrides].to_dict()
            _dict['presetOverrides'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of each item in add_tables (list)
        _items = []
        if self.add_tables:
            for _item_add_tables in self.add_tables:
                if _item_add_tables:
                    _items.append(_item_add_tables.to_dict())
            _dict['addTables'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in custom (list)
        _items = []
        if self.custom:
            for _item_custom in self.custom:
                if _item_custom:
                    _items.append(_item_custom.to_dict())
            _dict['custom'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CoreV1alpha1DataSourceSpecGold from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "usePreset": obj.get("usePreset"),
            "presetOverrides": dict(
                (_k, CoreV1alpha1DataSourceSpecGoldPresetOverridesValue.from_dict(_v))
                for _k, _v in obj["presetOverrides"].items()
            )
            if obj.get("presetOverrides") is not None
            else None,
            "addTables": [CoreV1alpha1DataSourceSpecGoldAddTablesInner.from_dict(_item) for _item in obj["addTables"]] if obj.get("addTables") is not None else None,
            "custom": [CoreV1alpha1DataSourceSpecGoldCustomInner.from_dict(_item) for _item in obj["custom"]] if obj.get("custom") is not None else None
        })
        return _obj


